# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "scala_endpoint_rule-JaxWsEndpoint"
  languages:
  - "scala"
  message: |
    This method is part of a SOAP Web Service (JSR224). The security of this web service should be
    analyzed. For example:
    - Authentication, if enforced, should be tested.
    - Access control, if enforced, should be tested.
    - The inputs should be tracked for potential vulnerabilities.
    - The communication should ideally be over SSL.
  metadata:
    category: "security"
    cwe: "CWE-20"
    owasp: "A7:2017-Cross-Site Scripting (XSS)"
    shortDescription: "Improper Input Validation"
    technology:
    - "scala"
    security-severity: "Info"
  mode: "taint"
  pattern-sinks:
  - pattern: "<...$VAR...>"
  pattern-sources:
  - patterns:
    - pattern-inside: |
        @javax.jws.WebMethod(...)
        def $FUNC(..., $VAR: $TYPE, ...) = ...
    - pattern: "$VAR"
  severity: "INFO"
